#include "defs.h"

void dump_to_photo(PhotoHandle pp, unsigned char *RGB, int height, int width)
{
  PhotoImage output;
  int i;

  output.ptr = RGB;
  output.width = width;
  output.height = height;
  output.pitch = width*3;
  output.pixel_size = 3;
  for (i=0; i<3; i++)
    output.comp_off[i] = i;

  PhotoPutBlock(pp, &output, 0, 0, output.width, output.height);
}

/* assumes filenames[1] is top left, filenames[2] is top right, */
/* filenames[3] is bottom left, filenames[4] is bottom right */
/* does nothing if one or more of the files given does not exist */ 
void concat_files(PhotoHandle pp, char* filenames[4])
{
  pixel **tempcolors[4];
  unsigned char *big;
  int i,j, temp, temp2;
  int height[4];
  int width[4];
  int maxval;
  int bigPtr;
  int TotalHeight, TotalWidth;

  for (i=0; i<4; i++)
    if (fopen(filenames[i], "r") == NULL)
      {
	printf ("File %s does not exist\n", filenames[i]);
	return;
      }

  for (i=0; i<4; i++)
    process(filenames[i], &(height[i]), &(width[i]), &maxval,
	    &(tempcolors[i]));

  TotalHeight = height[0]+height[2];
  TotalWidth = width[0]+width[1];

  big = malloc(TotalHeight*TotalWidth*3*sizeof(unsigned char));
  bigPtr = 0;

  for (i=0; i<height[0]; i++)
    {
      for (j=0; j<width[0]; j++)
	{
	  big[bigPtr] = tempcolors[0][i][j].red;
	  big[bigPtr+1] = tempcolors[0][i][j].green;
	  big[bigPtr+2] = tempcolors[0][i][j].blue;
	  bigPtr += 3;
	}
      for (j=0; j<width[1]; j++)
	{
	  big[bigPtr] = tempcolors[1][i][j].red;
	  big[bigPtr+1] = tempcolors[1][i][j].green;
	  big[bigPtr+2] = tempcolors[1][i][j].blue;
	  bigPtr += 3;
	}
    }
  for (i=0; i<height[2]; i++)
    {
      for (j=0; j<width[0]; j++)
	{
	  big[bigPtr] = tempcolors[2][i][j].red;
	  big[bigPtr+1] = tempcolors[2][i][j].green;
	  big[bigPtr+2] = tempcolors[2][i][j].blue;
	  bigPtr += 3;
	}
      for (j=0; j<width[1]; j++)
	{
	  big[bigPtr] = tempcolors[3][i][j].red;
	  big[bigPtr+1] = tempcolors[3][i][j].green;
	  big[bigPtr+2] = tempcolors[3][i][j].blue;
	  bigPtr += 3;
	}
    }
  dump_to_photo(pp, big, TotalHeight, TotalWidth);
  for (i=0; i<4; i++)
    cleanup(tempcolors[i], height[i]);
  free(big);
}


